<?php /*
Plugin Name: RV Menu Tree
Version: 2.0.c
Plugin URI: http://piwigo.org/ext/extension_view.php?eid=238
Description: Replaces the categories in the menu bar with a nicer one (javascript).
Author: rvelices
Author URI: http://www.modusoptimus.com
*/

if (!function_exists('rv_ua_is_handheld'))
{
	function rv_ua_is_handheld()
	{
		if ( isset($_SESSION['is_handheld']) )
			return $_SESSION['is_handheld'];
		$ret=false;
		if ( strpos($_SERVER['HTTP_USER_AGENT'], 'BlackBerry')!==false )
			$ret=true;
		if ( session_id()!="" )
			$_SESSION['is_handheld']=$ret;
		return $ret;
	}
}

add_event_handler('get_categories_menu_sql_where', 'rv_mt_get_categories_menu_sql_where', EVENT_HANDLER_PRIORITY_NEUTRAL, 3 );

function rv_mt_get_categories_menu_sql_where($where, $expand, $filter)
{
	if (rv_ua_is_handheld()) return $where;
	add_event_handler('get_html_menu_category', 'rv_mt_get_html_menu_category', EVENT_HANDLER_PRIORITY_NEUTRAL, 3);

	if ($expand)
		return $where;
	if ($filter)
	{
		global $rv_mt_all_open;
		$rv_mt_all_open = true;
		return $where;
	}

	global $page;
	if ( !isset($page['category']) )
		$where = 'id_uppercat IS NULL OR uppercats REGEXP \'^[0-9]+,[0-9]+$\'';
	else
	{
		$where = 'id_uppercat is NULL
  OR uppercats LIKE "'.$page['category']['upper_names'][0]['id'].',%"
  OR uppercats REGEXP \'^[0-9]+,[0-9]+$\'';
	}
	return $where;
}


function rv_mt_get_html_menu_category($menu, $categories, $selected_category)
{
	$start = get_moment();

	$ref_level = 0;
	$level = 0;
	$menu = '';

	$upper_ids=array();
	if ( null!=$selected_category)
		$upper_ids = array_flip( explode(',', $selected_category['uppercats']) );

	$url_perma = make_index_url( array( 'category' => array('id'=>0, 'name'=>'', 'permalink'=> '@permalink@') ) );
	$url_no_perma = make_index_url( array( 'category' => array('id'=>999999, 'name'=>'xxxnamexxx', 'permalink'=> '') ) );

	foreach ($categories as $category)
	{
		$level = substr_count($category['global_rank'], '.') + 1;
		if ($level > $ref_level)
		{
			if ($ref_level==0)
				$menu.= "\n<ul class=\"rvTree\" id=\"theCategoryMenu\">";
			else
				$menu.= "\n<ul>";
		}
		elseif ($level == $ref_level)
			$menu.= "</li>";
		elseif ($level < $ref_level)
		{
			// we may have to close more than one level at the same time...
			$menu.= "</li>";
			$menu.= str_repeat("\n</ul></li>",($ref_level-$level));
		}
		$ref_level = $level;

		$menu.= "\n<li";
		$class_names = array();
		if ($category['id'] == @$selected_category['id'])
			array_push( $class_names, 'selected');
		global $rv_mt_all_open;

		if ($category['count_categories']>0)
		{
			if ( isset($rv_mt_all_open) and $rv_mt_all_open )
				array_push( $class_names, 'liOpen');
			elseif ( isset( $upper_ids[ $category['id'] ] ) )
			{
				array_push( $class_names, 'liOpen');
				unset($upper_ids[ $category['id'] ] );
			}
			else
				array_push( $class_names, 'liClosed');
		}

		if (count($class_names))
			$menu.= ' class="'.implode($class_names,' ').'"';
		$menu.= '>';

		if ( empty($category['permalink']) )
			$url = str_replace( array('999999', 'xxxnamexxx'), array($category['id'], str2url($category['name'])), $url_no_perma);
		else
			$url = str_replace('@permalink@', $category['permalink'], $url_perma);

		$title = get_display_images_count(
							$category['nb_images'], $category['count_images'], $category['count_categories'],
							false,
							' / '
						);

		$menu.= '<a href="'.$url.'"';
		if ($selected_category!=null and $category['id'] == $selected_category['id_uppercat'])
			$menu.= ' rel="up"';
		$menu.= ' title="'.$title.'">'
			.trigger_event('render_category_name', $category['name'], 'get_html_menu_category')
			//.$category['name']
			.'</a>';

		if ( $category['count_images']>0 )
		{// at least one direct or indirect image
			$menu.= '<span class="menuInfoCat'
				.($category['nb_images'] == 0 ? 'ByChild' : '')
				.'" title="'.$title.'"> ['.$category['count_images'].']</span>';
		}
		$menu.= get_icon($category['max_date_last'], @$category['max_date_last']> @$category['date_last']);
	}

	$menu.= str_repeat("\n</li></ul>",($level));
	$menu.= '<script type="text/javascript">RVTree.convertTree( document.getElementById("theCategoryMenu") );</script>';

	$dirname = dirname(__FILE__);
	$head = '<style type="text/css">'. str_replace( 'url(', 'url('.get_root_url().'plugins/'.basename($dirname).'/',file_get_contents($dirname.'/rvtree-min.css')).'</style>
<script type="text/javascript" src="'.get_root_url().'plugins/'. basename(dirname(__FILE__)).'/rvtree-min.js"></script>';

	pwg_debug('rv_mt_get_html_menu_category took '.number_format(get_moment() - $start,3,'.',' ') );
	global $template;
	$template->append( 'head_elements', $head);
	return $menu;
}
?>